# --------------------------------------------------------------------------------------------- #
""" Pyon: Base Encoder """
# --------------------------------------------------------------------------------------------- #

from abc import ABC

# --------------------------------------------------------------------------------------------- #
# pylint: disable=too-few-public-methods
# --------------------------------------------------------------------------------------------- #

class BaseEncoder(ABC):
    """ Base Encoder """

    # ----------------------------------------------------------------------------------------- #

    def __init__(self, encoder):
        """ Initializes a Base Encoder """

        # . ...
        if encoder is None:
            raise ValueError("Invalid Pyon Encoder")

        # . ...
        self.__encoder = encoder

    # ----------------------------------------------------------------------------------------- #

    def _encode(self, value):
        return self.__encoder.encode(value)

    # ----------------------------------------------------------------------------------------- #

    def _decode(self, value):
        return self.__encoder.decode(value)

    # ----------------------------------------------------------------------------------------- #


# --------------------------------------------------------------------------------------------- #
