# --------------------------------------------------------------------------------------------- #
""" Pyon: Base Encoder """
# --------------------------------------------------------------------------------------------- #


class BaseEnc():
    """ Base Encoder """

    # ----------------------------------------------------------------------------------------- #

    def encode(self, value):
        """ Encodes the value """

        # 1. ...
        return value if self.is_encode(value) else None

    # ----------------------------------------------------------------------------------------- #

    def decode(self, value):
        """ Decodes the value """

        # 1. ...
        return self.encode(value)

    # ----------------------------------------------------------------------------------------- #

    def is_encode(self, value):
        """ 
            Checks if Base Types:
            - `bool`, `float`, `int`, `str`, `None`
        """

        # 1. ...
        return isinstance(value, (int, float, str, bool)) or (value is None)

    # ----------------------------------------------------------------------------------------- #

    def is_decode(self, value):
        """ 
            Checks if Datetime Types:
            - `datetime.date`, `datetime.datetime`, `datetime.time`
        """

        # 1. ...
        return self.is_encode(value)

    # ----------------------------------------------------------------------------------------- #


# --------------------------------------------------------------------------------------------- #
